program matrix
  use m_mxv
  use omp_lib
  
  integer :: M, N

  !integer :: M = 2000, N = 2000

  double precision, dimension(:), allocatable :: A
  double precision, dimension(:), allocatable :: y
  double precision, dimension(:), allocatable :: x
  double precision :: tmp
  integer :: i, j
  double precision :: time1, time2

  read*, M

  N = M


  allocate(A(M * N), y(M), x(N))

!$omp parallel
!$omp do
  do i=1, M * N
     A(i) = 1.0
  enddo
!$omp end do
!$omp do
  do i=1, N
     x(i) = 1.0
  enddo
!$omp end do
!$omp end parallel
  time1 = omp_get_wtime()
  call mxv(A, M, N, x, y)
  time2 = omp_get_wtime()
  print*, omp_get_max_threads(), time2 - time1
end program matrix
